VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Labels"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
'Dim par As Parents
'Dim bill As Bills

Dim label_Printer As Printer
Dim label_Font As Font
Dim two_cols As Boolean
Dim label_count As Integer

Dim labelDevice As String
Dim labelDriver As String
Dim labelPort As String
Dim stp As New Setupdata
Dim pr_saved As Printer

Dim left_flag As Boolean    'false if left label
'bookmarks for 2 label records
Dim leftbook As String, rightbook As String

Const Twips_Per_Inch = 1440#
Const Labelrows_perpage = 10
'Public Sub setParBills(p As Parents, b As Bills)
'Set par = p
'Set bill = b
'End Sub
Private Sub Class_Initialize()
Dim prn As Printer
labelDevice = stp.getProfile("Labels", "Printername", Printer.DeviceName)
labelDriver = stp.getProfile("Labels", "Driver", Printer.DriverName)
labelPort = stp.getProfile("Labels", "Port", Printer.port)
Set label_Font = read_font(stp.getProfile("Labels", "Font", Printer.FontName + ",0,0"))
For Each prn In Printers
  If prn.DeviceName = labelDevice And prn.DriverName = labelDriver Then
    Set label_Printer = prn
  End If
Next prn
two_cols = False
push_printer
On Local Error GoTo nobin
Printer.PaperBin(vbPRBNTractor) = True
pop_printer
Exit Sub

nobin:
  two_cols = True
  Resume Next
End Sub
Private Function read_font(s$) As Font
Dim i As Integer
Dim fnt As New StdFont
'converts string in form
' Fontname, fontsize, bold, italic
'into values in font structure

fnt.Name = get_token$(s$)
If Trim$(fnt.Name) = "" Then
  fnt.Name = "Courier"
End If
Dim sz As Integer
sz = val(get_token$(s$))
If sz <= 0 Then
  sz = 10
End If
fnt.Size = sz
fnt.Bold = val(get_token$(s$)) <> 0
fnt.Italic = val(s$) <> 0
Set read_font = fnt
End Function
Property Let labelFont(fn As Font)
 label_Font = fn
write_font_info
End Property
Property Let labelPrinter(pr As Printer)
 Set label_Printer = pr
 labelDevice = pr.DeviceName
 labelDriver = pr.DriverName
 labelPort = pr.port
 stp.putProfile "Labels", "Printername", labelDevice
 stp.putProfile "Labels", "Driver", labelDriver
 stp.putProfile "Labels", "Port", labelPort
End Property
Property Get labelFont() As Font
Set labelFont = label_Font
End Property
Property Get labelPrinter() As Printer
Set labelPrinter = label_Printer
End Property

Private Function get_token$(s$)
'removes one comma-delimited token from the string
Dim i As Integer

i = InStr(s$, ",")
If i > 0 Then
  get_token$ = Left$(s$, i - 1)
  s$ = Right$(s$, Len(s$) - i)
Else
  get_token = s$
End If
End Function
Private Sub write_font_info()
'Converts into comma-delimited font string for ini-file
Dim ans As Integer, s$
s$ = Trim$(label_Font.FontName) + "," + Str$(label_Font.FontSize)
s$ = s$ + "," + Str$(label_Font.Bold) + "," + Str$(label_Font.Italic)
stp.putProfile "Labels", "Font", s$

End Sub
Public Sub printLabels(rec As Recordset, showBalance As Boolean)
push_printer
rec.MoveFirst
label_count = 0 'counts rows of labels
While Not rec.EOF
  print_label rec, showBalance
  rec.MoveNext
Wend
Printer.NewPage
Printer.EndDoc
pop_printer
End Sub
Private Sub print_label(rec As Recordset, showBalance As Boolean)
Dim lname$, ladd$, ltown$
If two_cols Then
  If left_flag Then
    leftbook = rec.Bookmark
    left_flag = False
  Else
    rightbook = rec.Bookmark
    rec.Bookmark = leftbook
    lname$ = make_name(rec, showBalance)
    ladd$ = rec![address]
    ltown$ = make_town(rec)
    rec.Bookmark = rightbook
    Printer.CurrentX = 0.25 * Twips_Per_Inch
    Printer.Print lname$;
    Printer.CurrentX = 4.25 * Twips_Per_Inch
    Printer.Print make_name(rec, showBalance)
    Printer.CurrentX = 0.25 * Twips_Per_Inch
    Printer.Print ladd$;
    Printer.CurrentX = 4.25 * Twips_Per_Inch
    Printer.Print rec![address]
    Printer.CurrentX = 0.25 * Twips_Per_Inch
    Printer.Print ltown$;
    Printer.CurrentX = 4.25 * Twips_Per_Inch
    Printer.Print make_town(rec)
    label_count = label_count + 1
    left_flag = True
    If label_count < 10 Then
      Printer.CurrentY = label_count * Twips_Per_Inch
    Else
      Printer.NewPage
      label_count = 0
      leftbook = ""
      left_flag = True
    End If
  End If
  
Else
  Printer.Print make_name(rec, showBalance)
  Printer.Print rec![address]
  Printer.Print make_town(rec)
  Printer.NewPage
End If
End Sub
Private Function make_name(rec As Recordset, bal As Boolean) As String
Dim lname$
 lname$ = rec![Fname1]
 If Len(rec![Fname2]) > 0 Then
   lname$ = lname$ + rec![Fname2] + " "
 End If
 lname$ = lname$ + rec![lname]
 If Len(rec![Lname2]) > 0 Then
   lname$ = lname$ + " " + rec![Lname2]
 End If
make_name = lname$
End Function
Private Function make_town(rec As Recordset) As String
 make_town = rec![Town] + ", " + rec![State] + " " + rec![zip]
End Function
Private Sub push_printer()
Set pr_saved = Printer
Set Printer = label_Printer
End Sub
Private Sub pop_printer()
Set Printer = pr_saved
End Sub
Private Sub old_print_labels(twocolumns As Integer, narrow As Integer, labellines)

Dim f As Integer, lb$, linecnt As Integer, i As Integer
Const BUFMAX = 12
ReDim buf$(BUFMAX), buf1$(BUFMAX)
Dim labelcount As Integer, bufcnt As Integer
Dim found As Integer, tabcol As Integer, buf1cnt As Integer, bcnt As Integer
Dim j As Integer, lperpage As Integer, ans As Integer
Dim CurrentX As Integer, CurrentY As Integer
'----------------------------------------
' Generic label printing routine
' Reads in the buffer file "labels.tmp" and
' prints labels delimited by a row of asterisks
' if columns = 2 then it prints 2 columns by 7 labels
'----------------------------------------
Dim DC As Integer, hFont  As Integer
Dim hOldFont As Integer, longorg As Long

Dim Docname$, result As Integer
Dim st$, x As Integer, y As Integer
Dim drv$, dev$, port$, dpi As Single, FontSize As Single
Dim lb_X As Integer, lb_Y As Integer
Dim Twips_Per_Inch As Single
lb_X = 0
lb_Y = 0
'IBM Proprinter II=proprint,LPT2:
drv$ = "proprint"
'drv$ = RTrim$(device(2).pdriver)
'dev$ = RTrim$(device(2).pname)
'port$ = "lpt2:"
'port$ = RTrim$(device(2).pport)

'alert the print manager
' start a new document
tabcol = 67
f = FreeFile
If Len(Dir$("labels.tmp")) > 0 Then
  Open "labels.tmp" For Input As #f
If Not twocolumns Then
  linecnt = 0
  labelcount = 0
'  result = EndPage%(DC)     'one blank label sets fonts
 ' result = StartPage%(DC)
  While Not EOF(f)
    ans = DoEvents()
    Line Input #f, lb$
    If Left$(lb$, 1) <> "*" Then
'      Call ltag_print(DC, lb$)
'      lbl_printcr DC
      linecnt = linecnt + 1
    Else                        'space to bottom of label
      labelcount = labelcount + 1   'count page labels
 '     result = EndPage%(DC)
 '     result = StartPage%(DC)
      lb_Y = 0
      linecnt = 0           'and reset line counter
    End If
   Wend
Else ' HPLASER labels
'--------------------2 column laser labels 7 x 2 per page---------------
' or 10 x 2 per page
'-----------------------------------------------------------------
labelcount = 0
If labellines = 8 Then
  lperpage = 7
'  lb_Y = twips_per_inch * .25
'  lb_Y = dpi * .25
  lb_Y = dpi * 7 / 8
Else
  lperpage = 10
  lb_Y = Twips_Per_Inch * 0.5
  lb_Y = dpi * 0.5
End If
  CurrentY = lb_Y
bufcnt = 1

While Not EOF(f)
  bufcnt = 1
  linecnt = 1

  '--------- print 1 or two labels-------------------
  i = 1
'  Call readbuf(f, buf$(), BUFMAX, bufcnt)
'  Call readbuf(f, buf1$(), BUFMAX, buf1cnt)
  bcnt = bufcnt
  If bcnt < buf1cnt Then bcnt = buf1cnt
  For j = 1 To bcnt
    'lb_X = .5 * twips_per_inch
    lb_X = 0.5 * dpi
 '   Call ltag_print(DC, " " + Left$(RTrim$(buf$(j)), tabcol - 2))
    lb_X = 4.25 * dpi
    'printer.CurrentX = CurrentX
  '  Call ltag_print(DC, " " + Left$(RTrim$(buf1$(j)), tabcol - 2))
    'result = EndPage%(DC)
   ' lbl_printcr DC
    linecnt = linecnt + 1
  Next j
  If labellines = 6 Then
    lb_Y = CurrentY + 1# * dpi  'from top of label
  Else
    lb_Y = CurrentY + (1 + 5 / 16) * dpi
  End If
    CurrentY = lb_Y           'new top of label
  lb_X = 0

  labelcount = labelcount + 1
  If labelcount >= lperpage Then
      labelcount = 0
'      result = EndPage%(DC)
'      result = StartPage%(DC)
      CurrentX = 0
      If labellines = 8 Then
        lb_Y = 0.25 * dpi
      Else
        lb_Y = 0.5 * dpi
      End If
      CurrentY = lb_Y
  End If

  ' If
  Wend
End If  'else 2 cols
Close #f
End If  'labels.tmp exists
' result = EndPage%(DC) '  Call page_eject                   'eject page

End Sub

