VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "dBase"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Private db As Database
Private ws As Workspace
Private dbOpened As Boolean
Private path$

Public Sub createDB(pathName$)
path$ = pathName$ + ".mdb"
If Len(Dir$(path$)) > 0 Then
  Kill path$
End If
Set db = ws.CreateDatabase(path$, dbLangGeneral)
dbOpened = True
End Sub
Public Sub Execute(sql$)
db.Execute sql$, dbFailOnError
End Sub
Public Function getPath() As String
getPath = path$
End Function
Public Sub BeginTrans()
 ws.BeginTrans  'mark beginning of transaction
End Sub
Public Sub Commit()
 ws.CommitTrans    'commit the transaction
End Sub
Public Sub RollBack()
 ws.RollBack        'undo the transaction
End Sub
Private Sub Class_Initialize()
Set ws = Workspaces(0)
dbOpened = False
End Sub
Public Function getDB() As Database
Set getDB = db
End Function
Public Sub openDB(file$)

'path$ = file$ + "SwimData.mdb"
path = file
If Len(Dir(file$)) > 0 Then
Set db = ws.openDatabase(file$)
dbOpened = True

'update to latest version
found = False
 For i = 0 To db.TableDefs.count - 1
   Set tb = db.TableDefs(i)
   If tb.Name = "Version" Then
     found = True
   End If
 Next i
 If Not found Then
   upgrade_11_12
 End If

End If
End Sub
Private Sub upgrade_11_12()
Dim ver As New version
Dim evnt As New Events

ver.setDB Me
ver.createTable
ver.setVersion "1.2"

evnt.setDB Me
evnt.upgrade_11_12

End Sub

Public Function createTable(nm$) As TableDef
Set createTable = db.CreateTableDef(nm$)
End Function
Public Sub appendTable(tb As TableDef)
db.TableDefs.Append tb
End Sub
Public Function openTableRecord(nm$) As Recordset
Set openTableRecord = db.OpenRecordset(nm$, dbOpenTable)
End Function
Public Function opened() As Boolean
opened = dbOpened
End Function
Public Function openRecord(query$) As Recordset
Dim rec As Recordset
Set rec = db.OpenRecordset(query$, dbOpenDynaset)
If Not rec.BOF Then
 rec.MoveLast
 rec.MoveFirst   'this sets the recordcount property
End If
Set openRecord = rec
End Function
Public Function openSnapshot(query$) As Recordset
Dim rec As Recordset
Set rec = db.OpenRecordset(query$, dbOpenSnapshot)
If rec.RecordCount > 0 Then
 rec.MoveLast
 rec.MoveFirst   'this sets the recordcount property
End If
Set openSnapshot = rec
End Function

Public Sub createRelation(nm$, host$, foreign$, key$)
Dim rel As Relation, tfield As Field
Set rel = db.createRelation(nm$)
rel.Table = host$
rel.ForeignTable = foreign$
Set tfield = rel.CreateField(key$)
tfield.ForeignName = key$
rel.Fields.Append tfield
db.Relations.Append rel

End Sub
Public Sub CloseDB()
db.Close
dbOpened = False
End Sub
