Attribute VB_Name = "dbHandler"
Option Explicit
Global Const REGISTERED = 1, RETIRED = 2, UNMATCHED = 3, DELETED = 4

Public Function createKey(tb As TableDef, nm$) As Field
Dim key As Field
Set key = tb.CreateField(nm$, dbLong)
key.Attributes = dbAutoIncrField
tb.Fields.Append key
Set createKey = key
End Function
Public Function createText(tb As TableDef, nm$, length As Integer)
Dim tx As Field
Set tx = tb.CreateField(nm$, dbText)
tx.Size = length
tx.AllowZeroLength = True
tb.Fields.Append tx
Set createText = tx
End Function
Public Function createDateField(tb As TableDef, nm$)
Dim dt As Field
Set dt = tb.CreateField(nm$, dbDate)
tb.Fields.Append dt
Set createDateField = dt
End Function
Public Sub makeIndex(tb As TableDef, nm$, primary As Boolean)
Dim pindex As index, pf As Field
Set pindex = tb.CreateIndex(nm$)
If primary Then
  pindex.primary = True
  pindex.Unique = True
Else
  pindex.primary = False
  pindex.Unique = False
End If
Set pf = pindex.CreateField(nm$)
pindex.Fields.Append pf
tb.Indexes.Append pindex
End Sub
Public Sub addField(rec As Recordset, F As Field, s As String)
rec.AddNew
rec![F] = s
rec.update
End Sub
Public Function createLong(tb As TableDef, nm$) As Field
Dim dt As Field
Set dt = tb.CreateField(nm$, dbLong)
tb.Fields.Append dt
Set createLong = dt
End Function

Public Function createSingle(tb As TableDef, nm$) As Field
Dim dt As Field
Set dt = tb.CreateField(nm$, dbSingle)
tb.Fields.Append dt
Set createSingle = dt
End Function
Public Function createBoolean(tb As TableDef, nm$) As Field
Dim dt As Field
Set dt = tb.CreateField(nm$, dbBoolean)
tb.Fields.Append dt
Set createBoolean = dt
End Function
Public Function getNull(s As Variant)
If IsNull(s) Then
 getNull = ""
Else
 getNull = s
End If
End Function
